/*
 * printsector.c
 *
 *	Prints out a particular sector
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

#define SECTOR_SIZE 512

void
main(int argc, char **argv)
{
    char *device;
    int sector;
    int fd;
    unsigned char buf[SECTOR_SIZE];
    int n, i, j, count, c;

    if (argc != 3 && argc != 4) {
	printf("Usage: %s <device> sector_number ?count?\n", argv[0]);
	exit(1);
    }
    device = argv[1];
    sector = atoi(argv[2]);
    if (argc == 4) {
	count = atoi(argv[3]);
    } else {
	count = 1;
    }
    fd = open(device, O_RDONLY);
    if (lseek(fd, sector * SECTOR_SIZE, SEEK_CUR) < 0) {
	printf("Unable to seek to desired location\n");
	exit(1);
    }
    for (c = 0; c < count; c++) {
	n = read(fd, buf, SECTOR_SIZE);
	if (n != SECTOR_SIZE) {
	    printf("Unable to read sector: %s\n", strerror(errno));
	    exit(1);
	}
	for (j = 0; j < SECTOR_SIZE; j += 16) {
	    printf("%08x: ", j + c*SECTOR_SIZE);
	    for (i = j; i < j + 16; i += 2) {
		printf("%02x%02x ", buf[i], buf[i+1]);
	    }
	    printf(" ");
	    for (i = j; i < j + 16; i ++) {
		if (isprint(buf[i])) {
		    printf("%c", buf[i]);
		} else {
		    printf(".");
		}
	    }
	    printf("\n");
	}
    }
}

